require "songs" --Require the lua file with all the song data

function love.load()
	listBalls = {} --Table for notes
	maxX = love.graphics.getWidth() --Silly (but useful!) variable
	timer = 0 --One timer.
	timer2 = 0 --Two timer.
	tim2 = false --Ha ha ha
	playin = false --Variable to see if music is still "playin"
	tracks.load() --Loads song data
end

function love.draw()
	love.graphics.setBackgroundColor(255,255,255)
	ballD() --Drawing the balls on the screen
	love.graphics.setColor(100,100,100)
	love.graphics.line(maxX/2,225,maxX/2,300) --Grey line marker in the middle
	love.graphics.line(maxX/2.68,250,maxX/2.68,270) --Grey line marker in the 3/4
	love.graphics.line(maxX/4,250,maxX/4,270) --Grey line marker in the 2/4
	love.graphics.line(maxX/8,250,maxX/8,270) --Grey line marker in the 1/4
	love.graphics.print(timer) --Print timer for debug stuff
	love.graphics.print(track1.name,0,15) --Print track name
	love.graphics.print(love.timer.getFPS(),0,30) --Print the FPS because why not.
	love.graphics.print(track1.numNotes.."/"..track1.noteMax,776,0) --How many notes youve hit in total
end

function love.update(dt)
	ballU() --Make sure the balls update
	if playin then --If the music is playing then make the timer go
		timer = timer + 1
	end
	listner() --Update for the listener, to listen to when the notes have to go
end

function listner() --Check when the balls have to go
	if timer > track1.notes[track1.notesNum] - 62 and track1.notesNum < 5 then --If timer is bigger than the note it should play with a delay then...
		table.insert(listBalls,balls()) --Insert a ball (note)
		track1.notesNum = track1.notesNum + 1 --Increment the note number
	end
end

function love.keypressed(key) --Pretty self explanatory
	if key == "a" then --If a is pressed add a test vall and make tim2 true
		table.insert(listBalls,balls())
		tim2 = true
	end
	if key == "w" then --If w pressed then reset the song and notes and stuff
		timer = 0
		playin = false
		track1.notesNum = 1
		track1.numNotes = 0
	end
	if key == "escape" then --Exit when esc is pressed
		love.event.quit()
	end
	for i ,v in ipairs(listBalls) do --For loop for balls
		if v.x + 31.25 > maxX/2 and v.x+18.75 < maxX/2 and key == "space" then --Change color of ball when hit correctly and increment note number
			v.c = {100,250,100}
			v.dh = true
			track1.numNotes = track1.numNotes + 1
		end
	end
	if key == "q" then --Start playing track
		love.audio.play(track1.song)
		if playin == false then --Start or stop music
			playin = true
		else
			playin = false
		end
	end
end

function balls() --Function to make balls
	ball = {}
	ball.c = {150,150,150} --Default start color
	ball.x = 0 --X position
	ball.y = 235 --Y position
	ball.dh = false --Did hit ball
	ball.m = false --Did miss ball
	return ball
end

function ballD() --Ball draw function
	for i, v in ipairs(listBalls) do --Ball for loop
		love.graphics.setColor(v.c) --Set the color of the ball
		love.graphics.rectangle("fill",v.x,v.y,50,50,50) --Draw a rectangle but then make it a circle WHAAAAAT???
	end
end

function ballU() --Ball update function
	for i ,v in ipairs(listBalls) do
		v.x = v.x + 5.8 --Make ball go forward
		if v.x + 5 > maxX/2 and v.dh == false then --If ball missed change color to red EW
			v.c = {250,150,150}
		end
		if v.x > maxX then --If ball reaches end of screen then kill it.
			table.remove(listBalls,i)
		end
		if v.x + 50 > maxX/2 and v.x < maxX/2 and v.dh == false then --Show if ball has the ability to hit.
			v.c = {100,100,255}
			tim2 = false --Some debug timer.
		end
	end
end